type 'a result
type 'a t = Strng.t -> 'a result

val (>>=)       : 'a t -> ('a -> 'b t) -> 'b t
val (<|>)       : 'a t -> 'a t -> 'a t
val (>>)        : 'a t -> 'b t -> 'b t
val any_char    : char t
val between     : 'o t -> 'a t -> 'c t -> 'a t
val char        : char -> char t
val digit       : char t
val letter      : char t
val many1       : 'a t -> ('a list) t
val many        : 'a t -> ('a list) t
val none_of     : string -> char t
val one_of      : string -> char t
val parse       : 'a t -> Strng.t -> 'a
val return      : 'a -> 'a t
val sat         : (char -> bool) -> char t
val sep_by1     : 'a t -> 's t -> ('a list) t
val sep_by      : 'a t -> 's t -> ('a list) t
val sep_end_by1 : 'a t -> 's t -> ('a list) t
val sep_end_by  : 'a t -> 's t -> ('a list) t
val skip_many1  : 'a t -> unit t
val skip_many   : 'a t -> unit t
val space       : char t
val spaces      : unit t
val string      : string -> Strng.t t
val tempt       : 'a t -> 'a t
val test        : 'a t -> string -> 'a
